## librabbitmq 0.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(rabbitmq-c "C")

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

set(RMQ_VERSION_MAJOR 0)
set(RMQ_VERSION_MINOR 3)
set(RMQ_VERSION_PATCH 0)

# Follow all steps below in order to calculate new ABI version when updating the library
# NOTE: THIS IS UNRELATED to the actual project version
#
# 1. If the library source code has changed at all since the last update, then increment revision
# 2. If any interfaces have been added, removed, or changed since the last update, increment current and set revision to 0.
# 3. If any interfaces have been added since the last public release, then increment age.
# 4. If any interfaces have been removed since the last public release, then set age to 0.

set(RMQ_SOVERSION_CURRENT   1)
set(RMQ_SOVERSION_REVISION  1)
set(RMQ_SOVERSION_AGE       0)

math(EXPR RMQ_SOVERSION_MAJOR "${RMQ_SOVERSION_CURRENT} - ${RMQ_SOVERSION_AGE}")
math(EXPR RMQ_SOVERSION_MINOR "${RMQ_SOVERSION_AGE}")
math(EXPR RMQ_SOVERSION_PATCH "${RMQ_SOVERSION_REVISION}")

set(RMQ_VERSION ${RMQ_SOVERSION_MAJOR}.${RMQ_SOVERSION_MINOR}.${RMQ_SOVERSION_PATCH})
set(RMQ_SOVERSION ${RMQ_SOVERSION_MAJOR})

set(VERSION ${RMQ_VERSION_MAJOR}.${RMQ_VERSION_MINOR}.${RMQ_VERSION_PATCH})

if (MSVC)
  set(CMAKE_C_FLAGS "/W4 /nologo ${CMAKE_C_FLAGS}")
elseif (CMAKE_COMPILER_IS_GNUCC)
  set(RMQ_C_FLAGS "-Wall -Wextra -pedantic -Wstrict-prototypes -Wcast-align -Wno-unused-function -fno-common")
  execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
  if (GCC_VERSION VERSION_GREATER 4.0 OR GCC_VERSION VERSION_EQUAL 4.0)
      set(RMQ_C_FLAGS "${RMQ_C_FLAGS} -fvisibility=hidden")
  endif()
  set(CMAKE_C_FLAGS "${RMQ_C_FLAGS} ${CMAKE_C_FLAGS}")
endif ()

if (CMAKE_GENERATOR MATCHES ".*(Make|Ninja).*"
    AND NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
  message(STATUS "CMAKE_BUILD_TYPE not specified. Creating ${CMAKE_BUILD_TYPE} build")
endif()

include(TestCInline)
include(CheckFunctionExists)
include(CheckLibraryExists)
include(CMakePushCheckState)

# Detect if we need to link against a socket library:
cmake_push_check_state()
if (WIN32)
  # Always use WinSock2 on Windows
  set(SOCKET_LIBRARIES ws2_32)
else ()
  # Is it in the default link?
  CHECK_FUNCTION_EXISTS(getaddrinfo HAVE_GETADDRINFO)
  if (NOT (HAVE_GETADDRINFO EQUAL 1))
    CHECK_LIBRARY_EXISTS(socket getaddrinfo "" HAVE_GETADDRINFO2)
    if (HAVE_GETADDRINFO2 EQUAL 1)
      set(SOCKET_LIBRARIES socket)
    else ()
      CHECK_LIBRARY_EXISTS("socket;nsl" getaddrinfo "" HAVE_GETADDRINFO3)
      if (HAVE_GETADDRINFO3 EQUAL 1)
        set(SOCKET_LIBRARIES socket nsl)
      else ()
        message(FATAL_ERROR "Cannot find name resolution library (containing symbol getaddrinfo)")
      endif ()
    endif ()
  endif ()

  set(CMAKE_REQUIRED_LIBRARIES ${SOCKET_LIBRARIES})
  CHECK_FUNCTION_EXISTS(socket HAVE_SOCKET)
  if (NOT HAVE_SOCKET EQUAL 1)
    CHECK_LIBRARY_EXISTS(socket socket "" HAVE_SOCKET2)
    if (NOT HAVE_SOCKET2 EQUAL 1)
      set(SOCKET_LIBRARIES socket ${SOCKET_LIBRARIES})
    else ()
      CHECK_LIBRARY_EXISTS("socket;nsl" socket "" HAVE_SOCKET3)
      if (HAVE_SOCKET3 EQUAL 1)
        set(SOCKET_LIBRARIES socket nsl ${SOCKET_LIBRARIES})
      else ()
        message(FATAL_ERROR "Cannot find socket library (containing symbol socket)")
      endif ()
    endif ()
  endif ()
endif ()
cmake_pop_check_state()

cmake_push_check_state()
set(CMAKE_REQUIRED_LIBRARIES ${SOCKET_LIBRARIES})
check_function_exists(htonll HAVE_HTONLL)
cmake_pop_check_state()

option(REGENERATE_AMQP_FRAMING "Regenerate amqp_framing.h/amqp_framing.c sources (for developer use)" OFF)
mark_as_advanced(REGENERATE_AMQP_FRAMING)

if (REGENERATE_AMQP_FRAMING)
  find_package(PythonInterp)
  if (NOT PYTHONINTERP_FOUND)
    message(FATAL_ERROR "REGENERATE_AMQP_FRAMING requires Python to be available")
  endif ()

  #Determine Python Version:
  if(PYTHON_EXECUTABLE)
    execute_process(COMMAND "${PYTHON_EXECUTABLE}" -c
      "import sys; sys.stdout.write(';'.join([str(x) for x in sys.version_info[:3]]))"
      OUTPUT_VARIABLE _VERSION
      RESULT_VARIABLE _PYTHON_VERSION_RESULT
      ERROR_QUIET)
    if(NOT _PYTHON_VERSION_RESULT)
      string(REPLACE ";" "." PYTHON_VERSION_STRING "${_VERSION}")
      list(GET _VERSION 0 PYTHON_VERSION_MAJOR)
      list(GET _VERSION 1 PYTHON_VERSION_MINOR)
      list(GET _VERSION 2 PYTHON_VERSION_PATCH)
      if(PYTHON_VERSION_PATCH EQUAL 0)
        # it's called "Python 2.7", not "2.7.0"
        string(REGEX REPLACE "\\.0$" "" PYTHON_VERSION_STRING "${PYTHON_VERSION_STRING}")
      endif()
    else()
      # sys.version predates sys.version_info, so use that
      execute_process(COMMAND "${PYTHON_EXECUTABLE}" -c "import sys; sys.stdout.write(sys.version)"
        OUTPUT_VARIABLE _VERSION
        RESULT_VARIABLE _PYTHON_VERSION_RESULT
        ERROR_QUIET)
      if(NOT _PYTHON_VERSION_RESULT)
        string(REGEX REPLACE " .*" "" PYTHON_VERSION_STRING "${_VERSION}")
        string(REGEX REPLACE "^([0-9]+)\\.[0-9]+.*" "\\1" PYTHON_VERSION_MAJOR "${PYTHON_VERSION_STRING}")
        string(REGEX REPLACE "^[0-9]+\\.([0-9])+.*" "\\1" PYTHON_VERSION_MINOR "${PYTHON_VERSION_STRING}")
        if(PYTHON_VERSION_STRING MATCHES "^[0-9]+\\.[0-9]+\\.[0-9]+.*")
          string(REGEX REPLACE "^[0-9]+\\.[0-9]+\\.([0-9]+).*" "\\1" PYTHON_VERSION_PATCH "${PYTHON_VERSION_STRING}")
        else()
          set(PYTHON_VERSION_PATCH "0")
        endif()
      else()
        # sys.version was first documented for Python 1.5, so assume
        # this is older.
        set(PYTHON_VERSION_STRING "1.4")
        set(PYTHON_VERSION_MAJOR "1")
        set(PYTHON_VERSION_MAJOR "4")
        set(PYTHON_VERSION_MAJOR "0")
      endif()
    endif()
    unset(_PYTHON_VERSION_RESULT)
    unset(_VERSION)
  endif(PYTHON_EXECUTABLE)

  # If we're running v3.x look for a 2to3 utility
  if (PYTHON_VERSION_MAJOR GREATER 2)
    get_filename_component(PYTHON_EXE_DIR ${PYTHON_EXECUTABLE} PATH)
    find_program(PYTHON_2TO3_EXECUTABLE
      NAMES 2to3
      HINTS ${PYTHON_EXE_DIR}
      )

    if ("PYTHON_2TO3_EXECUTABLE-NOTFOUND" STREQUAL PYTHON_2TO3_EXECUTABLE)
      message(FATAL_ERROR "Unable to find 2to3 python utility, specify python 2.7 or specify 2to3 utility")
    endif ()
  endif (PYTHON_VERSION_MAJOR GREATER 2)


  #check for json or simplejson
  execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "import json"
    RESULT_VARIABLE CHECK_PYTHON_JSON_FAILED
  )

  if (CHECK_PYTHON_JSON_FAILED)
    execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "import simplejson"
      RESULT_VARIABLE CHECK_PYTHON_SIMPLEJSON_FAILED
    )

    if (CHECK_PYTHON_SIMPLEJSON_FAILED)
      message(FATAL_ERROR "REGENERATE_AMQP_FRAMING requires a python with json or simplejson modules")
    endif (CHECK_PYTHON_SIMPLEJSON_FAILED)
  endif (CHECK_PYTHON_JSON_FAILED)


  find_path(AMQP_CODEGEN_DIR
    amqp_codegen.py
    PATHS ${CMAKE_CURRENT_SOURCE_DIR}/codegen
          ${CMAKE_CURRENT_SOURCE_DIR}/rabbitmq-codegen 
          ${CMAKE_CURRENT_SOURCE_DIR}/../rabbitmq-codegen
          DOC "Path to directory containing amqp_codegen.py (rabbitmq-codegen)"
          NO_DEFAULT_PATH
          )

  if (AMQP_CODEGEN_DIR STREQUAL "AMQP_CODEGEN_DIR-NOTFOUND")
    message(SEND_ERROR "REGENERATE_AMQP_FRAMING requires the amqp_codegen.py script. If this is a git clone you can:\n\ngit submodule init\ngit submodule update\n\n Or set AMQP_CODEGEN_DIR to directory containing amqp_codegen.py")
  else ()
    message(STATUS "Found amqp_codegen.py in ${AMQP_CODEGEN_DIR}")
  endif()
endif (REGENERATE_AMQP_FRAMING)

find_package(POPT)
find_package(XmlTo)

if (POPT_FOUND AND XmlTo_FOUND)
  set(DO_DOCS ON)
endif()

option(BUILD_SHARED_LIBS "Build rabbitmq-c as a shared library" ON)
option(BUILD_STATIC_LIBS "Build rabbitmq-c as a static library" OFF)

option(BUILD_EXAMPLES "Build Examples" ON)
option(BUILD_TOOLS "Build Tools (requires POPT Library)" ${POPT_FOUND})
option(BUILD_TOOLS_DOCS "Build man pages for Tools (requires xmlto)" ${DO_DOCS})
option(BUILD_TESTS "Build tests (run tests with make test)" ON)

if (NOT BUILD_SHARED_LIBS AND NOT BUILD_STATIC_LIBS)
    message(FATAL_ERROR "One or both of BUILD_SHARED_LIBS or BUILD_STATIC_LIBS must be set to ON to build")
endif()

if (WIN32 AND BUILD_STATIC_LIBS)
  message(FATAL_ERROR "The rabbitmq-c library cannot be built as a static library on Win32. Set BUILD_STATIC_LIBS=OFF to get around this.")
endif()

add_subdirectory(librabbitmq)

if (BUILD_EXAMPLES)
  add_subdirectory(examples)
endif ()

if (BUILD_TOOLS)
  if (POPT_FOUND)
    add_subdirectory(tools)
  else ()
    message(WARNING "POpt library was not found. Tools will not be built")
  endif ()
endif ()

if (BUILD_TESTS)
  enable_testing()
  add_subdirectory(tests)
endif (BUILD_TESTS)

set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_PREFIX}/bin)
set(libdir ${CMAKE_INSTALL_PREFIX}/lib)
set(includedir ${CMAKE_INSTALL_PREFIX}/include)

configure_file(cmake/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/librabbitmq/config.h)
configure_file(librabbitmq.pc.in ${CMAKE_CURRENT_BINARY_DIR}/librabbitmq.pc @ONLY)

install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/librabbitmq.pc
  DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/pkgconfig
  )

if (BUILD_SHARED_LIBS)
  message(STATUS "Building rabbitmq as a shared library - yes")
else ()
  message(STATUS "Building rabbitmq as a shared library - no")
endif ()

if (BUILD_STATIC_LIBS)
  message(STATUS "Building rabbitmq as a static library - yes")
else ()
  message(STATUS "Building rabbitmq as a static library - no")
endif ()

=== examples/CMakeLists.txt ===
include_directories(${LIBRABBITMQ_INCLUDE_DIRS})

if (WIN32)
    set(PLATFORM_DIR win32)
else (WIN32)
    set(PLATFORM_DIR unix)
endif (WIN32)

set(COMMON_SRCS
    utils.h
    utils.c
    ${PLATFORM_DIR}/platform_utils.c
    )

add_executable(amqp_sendstring amqp_sendstring.c ${COMMON_SRCS})
target_link_libraries(amqp_sendstring ${RMQ_LIBRARY_TARGET})

add_executable(amqp_rpc_sendstring_client amqp_rpc_sendstring_client.c ${COMMON_SRCS})
target_link_libraries(amqp_rpc_sendstring_client rabbitmq)

add_executable(amqp_exchange_declare amqp_exchange_declare.c ${COMMON_SRCS})
target_link_libraries(amqp_exchange_declare ${RMQ_LIBRARY_TARGET})

add_executable(amqp_listen amqp_listen.c ${COMMON_SRCS})
target_link_libraries(amqp_listen ${RMQ_LIBRARY_TARGET})

add_executable(amqp_producer amqp_producer.c ${COMMON_SRCS})
target_link_libraries(amqp_producer ${RMQ_LIBRARY_TARGET})

add_executable(amqp_consumer amqp_consumer.c ${COMMON_SRCS})
target_link_libraries(amqp_consumer ${RMQ_LIBRARY_TARGET})

add_executable(amqp_unbind amqp_unbind.c ${COMMON_SRCS})
target_link_libraries(amqp_unbind ${RMQ_LIBRARY_TARGET})

add_executable(amqp_bind amqp_bind.c ${COMMON_SRCS})
target_link_libraries(amqp_bind ${RMQ_LIBRARY_TARGET})

add_executable(amqp_listenq amqp_listenq.c ${COMMON_SRCS})
target_link_libraries(amqp_listenq ${RMQ_LIBRARY_TARGET})

=== librabbitmq/CMakeLists.txt ===
project(librabbitmq "C")

if (REGENERATE_AMQP_FRAMING)
  set(AMQP_CODEGEN_PY "${CMAKE_CURRENT_BINARY_DIR}/amqp_codegen.py")
  set(CODEGEN_PY "${CMAKE_CURRENT_BINARY_DIR}/codegen.py")
  set(AMQP_SPEC_JSON_PATH "${AMQP_CODEGEN_DIR}/amqp-rabbitmq-0.9.1.json")
  set(AMQP_FRAMING_H_PATH ${CMAKE_CURRENT_BINARY_DIR}/amqp_framing.h)
  set(AMQP_FRAMING_C_PATH ${CMAKE_CURRENT_BINARY_DIR}/amqp_framing.c)

  if (PYTHON_VERSION_MAJOR GREATER 2)
    set(CONVERT_CODEGEN ${PYTHON_2TO3_EXECUTABLE} -w ${CODEGEN_PY} > codegen_2to3.out)
    set(CONVERT_AMQP_CODEGEN ${PYTHON_2TO3_EXECUTABLE} -w ${AMQP_CODEGEN_PY} > amqp_codegen_2to3.out)
  else ()
    set(CONVERT_CODEGEN "")
    set(CONVERT_AMQP_CODEGEN "")
  endif ()

  add_custom_command(
    OUTPUT ${CODEGEN_PY}
    COMMAND ${CMAKE_COMMAND} ARGS -E copy ${CMAKE_CURRENT_SOURCE_DIR}/codegen.py ${CODEGEN_PY}
    COMMAND ${CONVERT_CODEGEN}
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/codegen.py
    VERBATIM)

  add_custom_command(
    OUTPUT ${AMQP_CODEGEN_PY}
    COMMAND ${CMAKE_COMMAND} ARGS -E copy ${AMQP_CODEGEN_DIR}/amqp_codegen.py ${AMQP_CODEGEN_PY}
    COMMAND ${CONVERT_AMQP_CODEGEN}
    DEPENDS ${AMQP_CODEGEN_DIR}/amqp_codegen.py ${AMQP_CODEGEN_TARGET}
    VERBATIM)

  add_custom_command(
    OUTPUT ${AMQP_FRAMING_H_PATH}
    COMMAND ${PYTHON_EXECUTABLE} ARGS ${CODEGEN_PY} header ${AMQP_SPEC_JSON_PATH} ${AMQP_FRAMING_H_PATH}
    DEPENDS ${AMQP_SPEC_JSON_PATH} ${CODEGEN_PY} ${AMQP_CODEGEN_PY}
    VERBATIM)

  add_custom_command(
    OUTPUT ${AMQP_FRAMING_C_PATH}
    COMMAND ${PYTHON_EXECUTABLE} ARGS ${CODEGEN_PY} body ${AMQP_SPEC_JSON_PATH} ${AMQP_FRAMING_C_PATH}
    DEPENDS ${AMQP_SPEC_JSON_PATH} ${CODEGEN_PY} ${AMQP_CODEGEN_PY}
    VERBATIM)
else (REGENERATE_AMQP_FRAMING)
  set(AMQP_FRAMING_H_PATH ${CMAKE_CURRENT_SOURCE_DIR}/amqp_framing.h)
  set(AMQP_FRAMING_C_PATH ${CMAKE_CURRENT_SOURCE_DIR}/amqp_framing.c)
endif (REGENERATE_AMQP_FRAMING)

if(WIN32)
  set(SOCKET_IMPL "win32")
else(WIN32)
  set(SOCKET_IMPL "unix")
endif(WIN32)

if(MSVC)
  if(MSVC_VERSION LESS 1600)
    set(MSINTTYPES_INCLUDE "${CMAKE_CURRENT_SOURCE_DIR}/win32/msinttypes")
    set(STDINT_H_INSTALL_FILE "${CMAKE_CURRENT_SOURCE_DIR}/win32/msinttypes/stdint.h")
  endif(MSVC_VERSION LESS 1600)
endif(MSVC)

# NOTE: order is important here: if we generate amqp_framing.h/.c it'll be in the
# binary directory, and should shadow whats in the source directory
set(LIBRABBITMQ_INCLUDE_DIRS
  ${CMAKE_CURRENT_BINARY_DIR}
	${CMAKE_CURRENT_SOURCE_DIR}
	${SOCKET_IMPL}
	${MSINTTYPES_INCLUDE}
	)

include_directories(${LIBRABBITMQ_INCLUDE_DIRS})

set(LIBRABBITMQ_INCLUDE_DIRS
	${LIBRABBITMQ_INCLUDE_DIRS}
	PARENT_SCOPE)

add_definitions(-DHAVE_CONFIG_H)

set(RABBITMQ_SOURCES
    ${AMQP_FRAMING_H_PATH}
    ${AMQP_FRAMING_C_PATH}
    amqp_api.c  amqp.h 
    amqp_connection.c  amqp_mem.c  amqp_private.h  amqp_socket.c  amqp_table.c
    amqp_url.c
    ${SOCKET_IMPL}/socket.h ${SOCKET_IMPL}/socket.c
)

add_definitions(-DAMQP_BUILD)

include(InstallMacros)

if (BUILD_SHARED_LIBS)
    add_library(rabbitmq SHARED ${RABBITMQ_SOURCES})

    if (WIN32)
        set_target_properties(rabbitmq PROPERTIES VERSION ${RMQ_VERSION} OUTPUT_NAME rabbitmq.${RMQ_SOVERSION})
    else (WIN32)
        set_target_properties(rabbitmq PROPERTIES VERSION ${RMQ_VERSION} SOVERSION ${RMQ_SOVERSION})
    endif (WIN32)

    if (DEFINED SOCKET_LIBRARIES)
      target_link_libraries(rabbitmq ${SOCKET_LIBRARIES})
    endif ()

    install(TARGETS rabbitmq
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib
        )
    install_pdb(rabbitmq)

    set(RMQ_LIBRARY_TARGET rabbitmq)
endif (BUILD_SHARED_LIBS)

if (BUILD_STATIC_LIBS)
    add_library(rabbitmq-static STATIC ${RABBITMQ_SOURCES})

    set_target_properties(rabbitmq-static PROPERTIES COMPILE_DEFINITIONS AMQP_STATIC)
    if (WIN32)
        set_target_properties(rabbitmq-static PROPERTIES VERSION ${RMQ_VERSION} OUTPUT_NAME librabbitmq.${RMQ_SOVERSION})
    else (WIN32)
        set_target_properties(rabbitmq-static PROPERTIES VERSION ${RMQ_VERSION} SOVERSION ${RMQ_SOVERSION} OUTPUT_NAME rabbitmq)
    endif (WIN32)

    if (DEFINED SOCKET_LIBRARIES)
      target_link_libraries(rabbitmq-static ${SOCKET_LIBRARIES})
    endif ()

    install(TARGETS rabbitmq-static
        ARCHIVE DESTINATION lib
        )
    install_pdb(rabbitmq-static)

    if (NOT DEFINED RMQ_LIBRARY_TARGET)
        set(RMQ_LIBRARY_TARGET rabbitmq-static)
    endif ()
endif (BUILD_STATIC_LIBS)

install(FILES amqp.h ${AMQP_FRAMING_H_PATH} ${STDINT_H_INSTALL_FILE}
	DESTINATION include
    )

set(RMQ_LIBRARY_TARGET ${RMQ_LIBRARY_TARGET} PARENT_SCOPE)

=== tests/CMakeLists.txt ===
include_directories(${LIBRABBITMQ_INCLUDE_DIRS})

if (MSVC)
  # No version of MSVC has inttypes.h, this uses the msinttypes
  #  Note this includes stdint.h which is either in 
  #  ../librabbitmq/win32/msinttypes or in a standard location
  include_directories(win32/msinttypes)
endif (MSVC)

add_executable(test_parse_url test_parse_url.c)
target_link_libraries(test_parse_url ${RMQ_LIBRARY_TARGET})
add_test(parse_url test_parse_url)

add_executable(test_tables test_tables.c)
target_link_libraries(test_tables ${RMQ_LIBRARY_TARGET})
add_test(tables test_tables)
configure_file(test_tables.expected ${CMAKE_CURRENT_BINARY_DIR}/tests/test_tables.expected COPY_ONLY)

=== tools/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${LIBRABBITMQ_INCLUDE_DIRS} ${POPT_INCLUDE_DIRS})

if (WIN32)
    set(PLATFORM_DIR win32)
    set(PLATFORM_SRCS
        win32/compat.c
        )
else (WIN32)
    set(PLATFORM_DIR unix)
endif (WIN32)

include_directories(${PLATFORM_DIR})

set(COMMON_SRCS
    common.h
    common.c
    ${PLATFORM_SRCS}
    )

add_executable(amqp-publish publish.c ${COMMON_SRCS})
target_link_libraries(amqp-publish ${RMQ_LIBRARY_TARGET} ${POPT_LIBRARY})

add_executable(amqp-get get.c ${COMMON_SRCS})
target_link_libraries(amqp-get ${RMQ_LIBRARY_TARGET} ${POPT_LIBRARY})

add_executable(amqp-consume consume.c ${PLATFORM_DIR}/process.c ${COMMON_SRCS})
target_link_libraries(amqp-consume ${RMQ_LIBRARY_TARGET} ${POPT_LIBRARY})

add_executable(amqp-declare-queue declare_queue.c ${COMMON_SRCS})
target_link_libraries(amqp-declare-queue ${RMQ_LIBRARY_TARGET} ${POPT_LIBRARY})

add_executable(amqp-delete-queue delete_queue.c ${COMMON_SRCS})
target_link_libraries(amqp-delete-queue ${RMQ_LIBRARY_TARGET} ${POPT_LIBRARY})

if (BUILD_TOOLS_DOCS)
  if (XmlTo_FOUND)
    set(DOCS_SRCS
      doc/amqp-consume.xml
      doc/amqp-declare-queue.xml
      doc/amqp-delete-queue.xml
      doc/amqp-get.xml
      doc/amqp-publish.xml
      doc/librabbitmq-tools.xml
      )

    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doc)
    set(XMLTO_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/doc/man-date.ent)
    add_custom_command(
            OUTPUT ${XMLTO_DEPENDS}
	          COMMAND date +'%Y-%m-%d' > ${XMLTO_DEPENDS}
            VERBATIM
            )

    set(XMLTO_COMMAND_ARGS --skip-validation --searchpath "${CMAKE_CURRENT_BINARY_DIR}/doc")

    XMLTO(${DOCS_SRCS}
      MODES man
      ALL)

    foreach(file ${XMLTO_FILES_man})
      get_filename_component(fileExt ${file} EXT)
      string( REGEX REPLACE "^[.]" "" fileExt ${fileExt} )
      install(
        FILES ${file}
        DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man${fileExt}
        )
    endforeach()

  else(XmlTo_FOUND)
    message(WARNING "xmlto not found, will not build tools documentation")
  endif(XmlTo_FOUND)
endif()

install(TARGETS amqp-publish amqp-get amqp-consume amqp-declare-queue amqp-delete-queue
	RUNTIME DESTINATION bin
	LIBRARY DESTINATION lib
	ARCHIVE DESTINATION lib
	PUBLIC_HEADER DESTINATION include)

## librabbitmq 0.0.1.hg216

=== debian/changelog ===
librabbitmq (0.0.1.hg216-1) unstable; urgency=low

  * Initial release. (Closes: #602549)

 -- Monty Taylor <mordred@inaugust.com>  Fri, 05 Nov 2010 11:37:32 -0700

=== debian/control ===
Source: librabbitmq
Priority: optional
Section: libs
Maintainer: Monty Taylor <mordred@inaugust.com>
Build-Depends: debhelper (>= 7.0.50),
 autoconf,
 automake,
 libtool,
 python-simplejson,
 libpopt-dev,
 xmlto
Standards-Version: 3.9.1
Homepage: http://www.rabbitmq.com/
Vcs-Browser: http://bazaar.launchpad.net/~mordred/librabbitmq/debian/files
Vcs-Bzr: http://bazaar.launchpad.net/~mordred/librabbitmq/debian

Package: librabbitmq-dev
Section: libdevel
Architecture: any
Depends: librabbitmq0 (= ${binary:Version}), ${misc:Depends}
Description: An AMQP client library written in C - Dev Files
 RabbitMQ provides robust messaging for applications. It is easy to use, fit
 for purpose at cloud scale and supported on all major operating systems and
 developer platforms. librabbitmq is a C-language AMQP client library for use
 with AMQP servers such as RabbitMQ speaking protocol versions 0-9-1.
 .
 This package provides the files needed for development.

Package: librabbitmq-dbg
Section: debug
Architecture: any
Priority: extra
Depends: librabbitmq0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: An AMQP client library written in C - Debug Files
 RabbitMQ provides robust messaging for applications. It is easy to use, fit
 for purpose at cloud scale and supported on all major operating systems and
 developer platforms. librabbitmq is a C-language AMQP client library for use
 with AMQP servers such as RabbitMQ speaking protocol versions 0-9-1.
 .
 This package provides debugging symbols.

Package: librabbitmq0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: An AMQP client library written in C
 RabbitMQ provides robust messaging for applications. It is easy to use, fit
 for purpose at cloud scale and supported on all major operating systems and
 developer platforms. librabbitmq is a C-language AMQP client library for use
 with AMQP servers such as RabbitMQ speaking protocol versions 0-9-1.
 .
 This package includes the library itself.

Package: amqp-tools
Architecture: any
Section: net
Depends: librabbitmq0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Command-line utilities for interacting with AMQP servers
 RabbitMQ provides robust messaging for applications. It is easy to use, fit
 for purpose at cloud scale and supported on all major operating systems and
 developer platforms. librabbitmq is a C-language AMQP client library for use
 with AMQP servers such as RabbitMQ speaking protocol versions 0-9-1.
 .
 This package includes command line utilities.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_strip:
	dh_strip --dbg-package=librabbitmq-dbg

get-orig-source:
	uscan --verbose --force-download --rename --repack --destdir=..

=== debian/watch ===
version=3
http://launchpad.net/librabbitmq/+download http://launchpad.net/librabbitmq/.*/librabbitmq-(.*)\.tar\.gz

## librabbitmq 0.3.0

=== debian/changelog ===
librabbitmq (0.3.0-1) unstable; urgency=low

  * New upstream release.
  * Set myself as maintainer.
  * Make package multi-arch.
  * Update to dh 9.
  * Force build with autotools.
  * Bump SONAME to 1 for libmemcached.
  * Bump Standards version to 3.9.4.
  * Use github tags in d/watch.
  * Build manpages from SGML sources.
  * Add dh-autoreconf to B-D.
  * Drop get-orig-source target.
  * Format packaging files with wrap-and-sort.
  * Update Homepage field.
  * Update information and format in d/copyright to DEP5.

 -- Michael Fladischer <FladischerMichael@fladi.at>  Thu, 06 Jun 2013 21:22:35 +0200

=== debian/control ===
Source: librabbitmq
Priority: optional
Section: libs
Maintainer: Michael Fladischer <FladischerMichael@fladi.at>
Build-Depends: debhelper (>= 9),
               dh-autoreconf,
               libpopt-dev,
               libtool,
               python-simplejson,
               docbook-to-man
Standards-Version: 3.9.4
Homepage: https://github.com/alanxz/rabbitmq-c
Vcs-Browser: http://bazaar.launchpad.net/~mordred/librabbitmq/debian/files
Vcs-Bzr: http://bazaar.launchpad.net/~mordred/librabbitmq/debian

Package: librabbitmq-dev
Section: libdevel
Architecture: any
Depends: librabbitmq1 (= ${binary:Version}), ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: AMQP client library written in C - Dev Files
 RabbitMQ provides robust messaging for applications. It is easy to use, fit
 for purpose at cloud scale and supported on all major operating systems and
 developer platforms. librabbitmq is a C-language AMQP client library for use
 with AMQP servers such as RabbitMQ speaking protocol versions 0-9-1.
 .
 This package provides the files needed for development.

Package: librabbitmq-dbg
Section: debug
Architecture: any
Priority: extra
Depends: librabbitmq1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: AMQP client library written in C - Debug Files
 RabbitMQ provides robust messaging for applications. It is easy to use, fit
 for purpose at cloud scale and supported on all major operating systems and
 developer platforms. librabbitmq is a C-language AMQP client library for use
 with AMQP servers such as RabbitMQ speaking protocol versions 0-9-1.
 .
 This package provides debugging symbols.

Package: librabbitmq1
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: AMQP client library written in C
 RabbitMQ provides robust messaging for applications. It is easy to use, fit
 for purpose at cloud scale and supported on all major operating systems and
 developer platforms. librabbitmq is a C-language AMQP client library for use
 with AMQP servers such as RabbitMQ speaking protocol versions 0-9-1.
 .
 This package includes the library itself.

Package: amqp-tools
Architecture: any
Section: net
Depends: librabbitmq1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Command-line utilities for interacting with AMQP servers
 RabbitMQ provides robust messaging for applications. It is easy to use, fit
 for purpose at cloud scale and supported on all major operating systems and
 developer platforms. librabbitmq is a C-language AMQP client library for use
 with AMQP servers such as RabbitMQ speaking protocol versions 0-9-1.
 .
 This package includes command line utilities.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with=autoreconf --buildsystem=autoconf

.PHONY: override_dh_strip
override_dh_strip:
	dh_strip --dbg-package=librabbitmq-dbg

.PHONY: override_dh_installman
override_dh_installman:
	set -e ; \
	for doc in consume declare-queue delete-queue get publish; do \
	  docbook-to-man tools/doc/amqp-$$doc.xml > amqp-$$doc.1; \
	done
	docbook-to-man tools/doc/librabbitmq-tools.xml > librabbitmq-tools.7
	dh_installman

=== debian/watch ===
version=3
https://github.com/alanxz/rabbitmq-c/tags \
/alanxz/rabbitmq-c/archive/rabbitmq-c-v([\d\.]+)\.tar\.gz

## librabbitmq 0.4.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,8 @@
+# vim:set ts=2 sw=2 sts=2 et:
 cmake_minimum_required(VERSION 2.6)
 project(rabbitmq-c "C")
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
-
-set(RMQ_VERSION_MAJOR 0)
-set(RMQ_VERSION_MINOR 3)
-set(RMQ_VERSION_PATCH 0)
 
 # Follow all steps below in order to calculate new ABI version when updating the library
 # NOTE: THIS IS UNRELATED to the actual project version
@@ -15,9 +12,9 @@
 # 3. If any interfaces have been added since the last public release, then increment age.
 # 4. If any interfaces have been removed since the last public release, then set age to 0.
 
-set(RMQ_SOVERSION_CURRENT   1)
+set(RMQ_SOVERSION_CURRENT   2)
 set(RMQ_SOVERSION_REVISION  1)
-set(RMQ_SOVERSION_AGE       0)
+set(RMQ_SOVERSION_AGE       1)
 
 math(EXPR RMQ_SOVERSION_MAJOR "${RMQ_SOVERSION_CURRENT} - ${RMQ_SOVERSION_AGE}")
 math(EXPR RMQ_SOVERSION_MINOR "${RMQ_SOVERSION_AGE}")
@@ -26,7 +23,16 @@
 set(RMQ_VERSION ${RMQ_SOVERSION_MAJOR}.${RMQ_SOVERSION_MINOR}.${RMQ_SOVERSION_PATCH})
 set(RMQ_SOVERSION ${RMQ_SOVERSION_MAJOR})
 
-set(VERSION ${RMQ_VERSION_MAJOR}.${RMQ_VERSION_MINOR}.${RMQ_VERSION_PATCH})
+file(STRINGS librabbitmq/amqp.h _API_VERSION_MAJOR REGEX "^#define AMQP_VERSION_MAJOR [0-9]+$")
+file(STRINGS librabbitmq/amqp.h _API_VERSION_MINOR REGEX "^#define AMQP_VERSION_MINOR [0-9]+$")
+file(STRINGS librabbitmq/amqp.h _API_VERSION_PATCH REGEX "^#define AMQP_VERSION_PATCH [0-9]+$")
+
+string(REGEX MATCH "[0-9]+" _API_VERSION_MAJOR ${_API_VERSION_MAJOR})
+string(REGEX MATCH "[0-9]+" _API_VERSION_MINOR ${_API_VERSION_MINOR})
+string(REGEX MATCH "[0-9]+" _API_VERSION_PATCH ${_API_VERSION_PATCH})
+
+# VERSION to match what is in autotools
+set(VERSION ${_API_VERSION_MAJOR}.${_API_VERSION_MINOR}.${_API_VERSION_PATCH})
 
 if (MSVC)
   set(CMAKE_C_FLAGS "/W4 /nologo ${CMAKE_C_FLAGS}")
@@ -47,6 +53,7 @@
 
 include(TestCInline)
 include(CheckFunctionExists)
+include(CheckSymbolExists)
 include(CheckLibraryExists)
 include(CMakePushCheckState)
 
@@ -92,8 +99,17 @@
 
 cmake_push_check_state()
 set(CMAKE_REQUIRED_LIBRARIES ${SOCKET_LIBRARIES})
-check_function_exists(htonll HAVE_HTONLL)
+if (WIN32)
+  check_symbol_exists(htonll Winsock2.h HAVE_HTONLL)
+else (WIN32)
+  check_function_exists(htonll HAVE_HTONLL)
+endif (WIN32)
 cmake_pop_check_state()
+
+check_library_exists(rt clock_gettime "time.h" CLOCK_GETTIME_NEEDS_LIBRT)
+if (CLOCK_GETTIME_NEEDS_LIBRT)
+  set(LIBRT rt)
+endif()
 
 option(REGENERATE_AMQP_FRAMING "Regenerate amqp_framing.h/amqp_framing.c sources (for developer use)" OFF)
 mark_as_advanced(REGENERATE_AMQP_FRAMING)
@@ -196,10 +212,13 @@
 
 find_package(POPT)
 find_package(XmlTo)
+find_package(Doxygen)
 
 if (POPT_FOUND AND XmlTo_FOUND)
   set(DO_DOCS ON)
 endif()
+
+find_package(Threads)
 
 option(BUILD_SHARED_LIBS "Build rabbitmq-c as a shared library" ON)
 option(BUILD_STATIC_LIBS "Build rabbitmq-c as a static library" OFF)
@@ -208,6 +227,30 @@
 option(BUILD_TOOLS "Build Tools (requires POPT Library)" ${POPT_FOUND})
 option(BUILD_TOOLS_DOCS "Build man pages for Tools (requires xmlto)" ${DO_DOCS})
 option(BUILD_TESTS "Build tests (run tests with make test)" ON)
+option(BUILD_API_DOCS "Build Doxygen API docs" ${DOXYGEN_FOUND})
+option(ENABLE_SSL_SUPPORT "Enable SSL support" ON)
+option(ENABLE_THREAD_SAFETY "Enable thread safety when using OpenSSL" ${Threads_FOUND})
+
+set(SSL_ENGINE "OpenSSL" CACHE STRING "SSL Backend to use, valid options: OpenSSL, cyaSSL, GnuTLS, PolarSSL")
+mark_as_advanced(SSL_ENGINE)
+
+if (ENABLE_SSL_SUPPORT)
+  if (SSL_ENGINE STREQUAL "OpenSSL")
+    find_package(OpenSSL 0.9.8 REQUIRED)
+
+  elseif (SSL_ENGINE STREQUAL "cyaSSL")
+    find_package(cyaSSL REQUIRED)
+
+  elseif (SSL_ENGINE STREQUAL "GnuTLS")
+    find_package(GnuTLS REQUIRED)
+
+  elseif (SSL_ENGINE STREQUAL "PolarSSL")
+    find_package(PolarSSL REQUIRED)
+
+  else()
+    message(FATAL_ERROR "Unsupported SSL_ENGINE ${SSL_ENGINE}, valid engines: OpenSSL, cyaSSL, GnuTLS, or PolarSSL")
+  endif()
+endif()
 
 if (NOT BUILD_SHARED_LIBS AND NOT BUILD_STATIC_LIBS)
     message(FATAL_ERROR "One or both of BUILD_SHARED_LIBS or BUILD_STATIC_LIBS must be set to ON to build")
@@ -236,10 +279,35 @@
   add_subdirectory(tests)
 endif (BUILD_TESTS)
 
+if (BUILD_API_DOCS)
+  if (NOT DOXYGEN_FOUND)
+    message(FATAL_ERROR "Doxygen is required to build the API documentation")
+  endif ()
+  configure_file(${CMAKE_SOURCE_DIR}/docs/Doxyfile.in ${CMAKE_BINARY_DIR}/docs/Doxyfile @ONLY)
+
+  add_custom_target(docs
+    COMMAND ${DOXYGEN_EXECUTABLE}
+    VERBATIM
+    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/docs
+    DEPENDS rabbitmq
+    COMMENT "Generating API documentation"
+    SOURCES ${CMAKE_SOURCE_DIR}/docs/Doxyfile.in
+    )
+endif ()
+
 set(prefix ${CMAKE_INSTALL_PREFIX})
-set(exec_prefix ${CMAKE_INSTALL_PREFIX}/bin)
-set(libdir ${CMAKE_INSTALL_PREFIX}/lib)
-set(includedir ${CMAKE_INSTALL_PREFIX}/include)
+set(exec_prefix "\${prefix}")
+set(libdir "\${exec_prefix}/lib")
+set(includedir "\${prefix}/include")
+set(libs_private ${SOCKET_LIBRARIES} ${LIBRT})
+if (ENABLE_SSL_SUPPORT)
+  if (SSL_ENGINE STREQUAL "OpenSSL")
+    set(requires_private "openssl")
+  endif()
+  if (ENABLE_THREAD_SAFETY)
+    set(libs_private ${libs_private} ${CMAKE_THREAD_LIBS_INIT})
+  endif()
+endif()
 
 configure_file(cmake/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/librabbitmq/config.h)
 configure_file(librabbitmq.pc.in ${CMAKE_CURRENT_BINARY_DIR}/librabbitmq.pc @ONLY)
@@ -258,5 +326,3 @@
 if (BUILD_STATIC_LIBS)
   message(STATUS "Building rabbitmq as a static library - yes")
 else ()
-  message(STATUS "Building rabbitmq as a static library - no")
-endif ()

=== librabbitmq/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,4 @@
+# vim:set ts=2 sw=2 sts=2 et:
 project(librabbitmq "C")
 
 if (REGENERATE_AMQP_FRAMING)
@@ -75,31 +76,71 @@
 
 add_definitions(-DHAVE_CONFIG_H)
 
+if (ENABLE_SSL_SUPPORT)
+  add_definitions(-DWITH_SSL=1)
+  set(AMQP_SSL_SOCKET_H_PATH amqp_ssl_socket.h)
+
+  if (SSL_ENGINE STREQUAL "OpenSSL")
+    set(AMQP_SSL_SRCS ${AMQP_SSL_SOCKET_H_PATH} amqp_openssl.c)
+    include_directories(${OPENSSL_INCLUDE_DIR})
+    set(AMQP_SSL_LIBS ${OPENSSL_LIBRARIES})
+
+  elseif (SSL_ENGINE STREQUAL "cyaSSL")
+    set(AMQP_SSL_SRCS ${AMQP_SSL_SOCKET_H_PATH} amqp_cyassl.c)
+    include_directories(${CYASSL_INCLUDE_DIR})
+    set(AMQP_SSL_LIBS ${CYASSL_LIBRARIES})
+
+  elseif (SSL_ENGINE STREQUAL "GnuTLS")
+    set(AMQP_SSL_SRCS ${AMQP_SSL_SOCKET_H_PATH} amqp_gnutls.c)
+    include_directories(${GNUTLS_INCLUDE_DIR})
+    add_definitions(${GNUTLS_DEFINITIONS})
+    set(AMQP_SSL_LIBS ${GNUTLS_LIBRARIES})
+
+  elseif (SSL_ENGINE STREQUAL "PolarSSL")
+    set(AMQP_SSL_SRCS ${AMQP_SSL_SOCKET_H_PATH} amqp_polarssl.c)
+    include_directories(${POLARSSL_INCLUDE_DIR})
+    set(AMQP_SSL_LIBS ${POLARSSL_LIBRARIES})
+
+  else()
+    message(FATAL_ERROR "Unknown SSL_ENGINE ${SSL_ENGINE}")
+  endif()
+
+  if (ENABLE_THREAD_SAFETY)
+    add_definitions(-DENABLE_THREAD_SAFETY)
+    if (WIN32)
+      set(AMQP_SSL_SRCS ${AMQP_SSL_SRCS} win32/threads.h win32/threads.c)
+    else()
+      set(AMQP_SSL_SRCS ${AMQP_SSL_SRCS} unix/threads.h)
+    endif()
+  endif()
+endif()
+
 set(RABBITMQ_SOURCES
     ${AMQP_FRAMING_H_PATH}
     ${AMQP_FRAMING_C_PATH}
-    amqp_api.c  amqp.h 
-    amqp_connection.c  amqp_mem.c  amqp_private.h  amqp_socket.c  amqp_table.c
-    amqp_url.c
-    ${SOCKET_IMPL}/socket.h ${SOCKET_IMPL}/socket.c
+    amqp_api.c amqp.h amqp_connection.c amqp_mem.c amqp_private.h amqp_socket.c
+    amqp_table.c amqp_url.c amqp_socket.h amqp_tcp_socket.c amqp_tcp_socket.h
+    amqp_timer.c amqp_timer.h
+    amqp_consumer.c
+    ${AMQP_SSL_SRCS}
 )
 
 add_definitions(-DAMQP_BUILD)
 
 include(InstallMacros)
 
+set(RMQ_LIBRARIES ${AMQP_SSL_LIBS} ${SOCKET_LIBRARIES} ${LIBRT} ${CMAKE_THREAD_LIBS_INIT})
+
 if (BUILD_SHARED_LIBS)
     add_library(rabbitmq SHARED ${RABBITMQ_SOURCES})
+
+    target_link_libraries(rabbitmq ${RMQ_LIBRARIES})
 
     if (WIN32)
         set_target_properties(rabbitmq PROPERTIES VERSION ${RMQ_VERSION} OUTPUT_NAME rabbitmq.${RMQ_SOVERSION})
     else (WIN32)
         set_target_properties(rabbitmq PROPERTIES VERSION ${RMQ_VERSION} SOVERSION ${RMQ_SOVERSION})
     endif (WIN32)
-
-    if (DEFINED SOCKET_LIBRARIES)
-      target_link_libraries(rabbitmq ${SOCKET_LIBRARIES})
-    endif ()
 
     install(TARGETS rabbitmq
         RUNTIME DESTINATION bin
@@ -114,16 +155,14 @@
 if (BUILD_STATIC_LIBS)
     add_library(rabbitmq-static STATIC ${RABBITMQ_SOURCES})
 
+    target_link_libraries(rabbitmq-static ${RMQ_LIBRARIES})
+
     set_target_properties(rabbitmq-static PROPERTIES COMPILE_DEFINITIONS AMQP_STATIC)
     if (WIN32)
         set_target_properties(rabbitmq-static PROPERTIES VERSION ${RMQ_VERSION} OUTPUT_NAME librabbitmq.${RMQ_SOVERSION})
     else (WIN32)
         set_target_properties(rabbitmq-static PROPERTIES VERSION ${RMQ_VERSION} SOVERSION ${RMQ_SOVERSION} OUTPUT_NAME rabbitmq)
     endif (WIN32)
-
-    if (DEFINED SOCKET_LIBRARIES)
-      target_link_libraries(rabbitmq-static ${SOCKET_LIBRARIES})
-    endif ()
 
     install(TARGETS rabbitmq-static
         ARCHIVE DESTINATION lib
@@ -135,9 +174,13 @@
     endif ()
 endif (BUILD_STATIC_LIBS)
 
-install(FILES amqp.h ${AMQP_FRAMING_H_PATH} ${STDINT_H_INSTALL_FILE}
-	DESTINATION include
+install(FILES
+  amqp.h
+  ${AMQP_FRAMING_H_PATH}
+  amqp_tcp_socket.h
+  ${AMQP_SSL_SOCKET_H_PATH}
+  ${STDINT_H_INSTALL_FILE}
+  DESTINATION include
     )
 
 set(RMQ_LIBRARY_TARGET ${RMQ_LIBRARY_TARGET} PARENT_SCOPE)
-

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,4 @@
+# vim:set ts=2 sw=2 sts=2 et:
 include_directories(${LIBRABBITMQ_INCLUDE_DIRS})
 
 if (MSVC)

=== tools/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,4 @@
+# vim:set ts=2 sw=2 sts=2 et:
 include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${LIBRABBITMQ_INCLUDE_DIRS} ${POPT_INCLUDE_DIRS})
 
 if (WIN32)
@@ -33,7 +34,7 @@
 target_link_libraries(amqp-delete-queue ${RMQ_LIBRARY_TARGET} ${POPT_LIBRARY})
 
 if (BUILD_TOOLS_DOCS)
-  if (XmlTo_FOUND)
+  if (XMLTO_FOUND)
     set(DOCS_SRCS
       doc/amqp-consume.xml
       doc/amqp-declare-queue.xml
@@ -66,9 +67,9 @@
         )
     endforeach()
 
-  else(XmlTo_FOUND)
+  else(XMLTO_FOUND)
     message(WARNING "xmlto not found, will not build tools documentation")
-  endif(XmlTo_FOUND)
+  endif(XMLTO_FOUND)
 endif()
 
 install(TARGETS amqp-publish amqp-get amqp-consume amqp-declare-queue amqp-delete-queue

=== debian/changelog ===
librabbitmq (0.4.1-1) unstable; urgency=low

  * Imported Upstream version 0.4.1
  * Add libssl-dev to Build-Depends.
  * Update librabbitmq1.symbols.
  * Switch buildsystem to cmake.
    + Add cmake_multiarch.patch to fix multiarch installation paths for shared
      library files in cmake.
    * Add cmake to Build-Depends.
    * Drop dh-autoreconf from Build-Depends.
  * Format packaging files with wrap-and-sort.
  * Update d/watch file to use github releases instead of tags.
  * Bump Standards version to 3.9.5.

 -- Michael Fladischer <FladischerMichael@fladi.at>  Mon, 04 Nov 2013 20:15:55 +0100

=== debian/control ===
--- 
+++ 
@@ -2,16 +2,17 @@
 Priority: optional
 Section: libs
 Maintainer: Michael Fladischer <FladischerMichael@fladi.at>
-Build-Depends: debhelper (>= 9),
-               dh-autoreconf,
+Build-Depends: cmake,
+               debhelper (>= 9),
+               docbook-to-man,
                libpopt-dev,
+               libssl-dev,
                libtool,
-               python-simplejson,
-               docbook-to-man
-Standards-Version: 3.9.4
+               python-simplejson
+Standards-Version: 3.9.5
 Homepage: https://github.com/alanxz/rabbitmq-c
-Vcs-Browser: http://bazaar.launchpad.net/~mordred/librabbitmq/debian/files
-Vcs-Bzr: http://bazaar.launchpad.net/~mordred/librabbitmq/debian
+Vcs-Git: git://anonscm.debian.org/collab-maint/librabbitmq.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/librabbitmq.git
 
 Package: librabbitmq-dev
 Section: libdevel

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 
 %:
-	dh $@ --with=autoreconf --buildsystem=autoconf
+	dh $@ --buildsystem=cmake
 
 .PHONY: override_dh_strip
 override_dh_strip:

## librabbitmq 0.5.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,9 +12,9 @@
 # 3. If any interfaces have been added since the last public release, then increment age.
 # 4. If any interfaces have been removed since the last public release, then set age to 0.
 
-set(RMQ_SOVERSION_CURRENT   2)
-set(RMQ_SOVERSION_REVISION  1)
-set(RMQ_SOVERSION_AGE       1)
+set(RMQ_SOVERSION_CURRENT   3)
+set(RMQ_SOVERSION_REVISION  2)
+set(RMQ_SOVERSION_AGE       2)
 
 math(EXPR RMQ_SOVERSION_MAJOR "${RMQ_SOVERSION_CURRENT} - ${RMQ_SOVERSION_AGE}")
 math(EXPR RMQ_SOVERSION_MINOR "${RMQ_SOVERSION_AGE}")
@@ -36,6 +36,8 @@
 
 if (MSVC)
   set(CMAKE_C_FLAGS "/W4 /nologo ${CMAKE_C_FLAGS}")
+elseif (CMAKE_C_COMPILER_ID MATCHES ".*Clang")
+  set(CMAKE_C_FLAGS "-Wall -Wextra -pedantic -Wstrict-prototypes -Wcast-align -Wno-unused-function -fno-common -fvisibility=hidden")
 elseif (CMAKE_COMPILER_IS_GNUCC)
   set(RMQ_C_FLAGS "-Wall -Wextra -pedantic -Wstrict-prototypes -Wcast-align -Wno-unused-function -fno-common")
   execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
@@ -56,6 +58,7 @@
 include(CheckSymbolExists)
 include(CheckLibraryExists)
 include(CMakePushCheckState)
+include(GNUInstallDirs)
 
 # Detect if we need to link against a socket library:
 cmake_push_check_state()
@@ -102,7 +105,7 @@
 if (WIN32)
   check_symbol_exists(htonll Winsock2.h HAVE_HTONLL)
 else (WIN32)
-  check_function_exists(htonll HAVE_HTONLL)
+  check_symbol_exists(htonll arpa/inet.h HAVE_HTONLL)
 endif (WIN32)
 cmake_pop_check_state()
 
@@ -283,22 +286,18 @@
   if (NOT DOXYGEN_FOUND)
     message(FATAL_ERROR "Doxygen is required to build the API documentation")
   endif ()
-  configure_file(${CMAKE_SOURCE_DIR}/docs/Doxyfile.in ${CMAKE_BINARY_DIR}/docs/Doxyfile @ONLY)
+  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/docs/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/docs/Doxyfile @ONLY)
 
   add_custom_target(docs
     COMMAND ${DOXYGEN_EXECUTABLE}
     VERBATIM
-    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/docs
+    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/docs
     DEPENDS rabbitmq
     COMMENT "Generating API documentation"
-    SOURCES ${CMAKE_SOURCE_DIR}/docs/Doxyfile.in
+    SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/docs/Doxyfile.in
     )
 endif ()
 
-set(prefix ${CMAKE_INSTALL_PREFIX})
-set(exec_prefix "\${prefix}")
-set(libdir "\${exec_prefix}/lib")
-set(includedir "\${prefix}/include")
 set(libs_private ${SOCKET_LIBRARIES} ${LIBRT})
 if (ENABLE_SSL_SUPPORT)
   if (SSL_ENGINE STREQUAL "OpenSSL")
@@ -309,20 +308,17 @@
   endif()
 endif()
 
+set(prefix ${CMAKE_INSTALL_PREFIX})
+set(exec_prefix "\${prefix}")
+set(libdir "\${exec_prefix}/${CMAKE_INSTALL_LIBDIR}")
+set(includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
+
 configure_file(cmake/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/librabbitmq/config.h)
 configure_file(librabbitmq.pc.in ${CMAKE_CURRENT_BINARY_DIR}/librabbitmq.pc @ONLY)
 
 install(FILES
   ${CMAKE_CURRENT_BINARY_DIR}/librabbitmq.pc
-  DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/pkgconfig
+  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
   )
 
 if (BUILD_SHARED_LIBS)
-  message(STATUS "Building rabbitmq as a shared library - yes")
-else ()
-  message(STATUS "Building rabbitmq as a shared library - no")
-endif ()
-
-if (BUILD_STATIC_LIBS)
-  message(STATUS "Building rabbitmq as a static library - yes")
-else ()

=== librabbitmq/CMakeLists.txt ===
--- 
+++ 
@@ -81,9 +81,18 @@
   set(AMQP_SSL_SOCKET_H_PATH amqp_ssl_socket.h)
 
   if (SSL_ENGINE STREQUAL "OpenSSL")
-    set(AMQP_SSL_SRCS ${AMQP_SSL_SOCKET_H_PATH} amqp_openssl.c)
+    set(AMQP_SSL_SRCS ${AMQP_SSL_SOCKET_H_PATH}
+        amqp_openssl.c
+        amqp_hostcheck.c
+        amqp_hostcheck.h
+    )
     include_directories(${OPENSSL_INCLUDE_DIR})
     set(AMQP_SSL_LIBS ${OPENSSL_LIBRARIES})
+    if (APPLE)
+      # Apple has deprecated OpenSSL in 10.7+. This disables that warning.
+      set_source_files_properties(${AMQP_SSL_SRCS}
+        PROPERTIES COMPILE_FLAGS -Wno-deprecated-declarations)
+    endif()
 
   elseif (SSL_ENGINE STREQUAL "cyaSSL")
     set(AMQP_SSL_SRCS ${AMQP_SSL_SOCKET_H_PATH} amqp_cyassl.c)
@@ -143,9 +152,9 @@
     endif (WIN32)
 
     install(TARGETS rabbitmq
-        RUNTIME DESTINATION bin
-        LIBRARY DESTINATION lib
-        ARCHIVE DESTINATION lib
+        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
+        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
         )
     install_pdb(rabbitmq)
 
@@ -165,7 +174,7 @@
     endif (WIN32)
 
     install(TARGETS rabbitmq-static
-        ARCHIVE DESTINATION lib
+        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
         )
     install_pdb(rabbitmq-static)
 
@@ -180,7 +189,7 @@
   amqp_tcp_socket.h
   ${AMQP_SSL_SOCKET_H_PATH}
   ${STDINT_H_INSTALL_FILE}
-  DESTINATION include
+  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
     )
 
 set(RMQ_LIBRARY_TARGET ${RMQ_LIBRARY_TARGET} PARENT_SCOPE)

=== tools/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # vim:set ts=2 sw=2 sts=2 et:
-include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${LIBRABBITMQ_INCLUDE_DIRS} ${POPT_INCLUDE_DIRS})
+include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${LIBRABBITMQ_INCLUDE_DIRS} ${POPT_INCLUDE_DIR})
 
 if (WIN32)
     set(PLATFORM_DIR win32)

=== debian/changelog ===
librabbitmq (0.5.2-2+deb8u1) jessie-security; urgency=high

  * CVE-2019-18609: Prevent an integer overflow that can lead to heap memory
    corruption; a rogue server could return a malicious frame header that leads
    to a smaller value than needed. (Closes: #946005)

 -- Chris Lamb <lamby@debian.org>  Fri, 06 Dec 2019 14:40:53 +0000

librabbitmq (0.5.2-2) unstable; urgency=medium

  * Add patch to enable SSL for tools (Closes: #764080).

 -- Michael Fladischer <FladischerMichael@fladi.at>  Fri, 17 Oct 2014 08:11:08 +0200

librabbitmq (0.5.2-1) unstable; urgency=medium

  * New upstream release (Closes: #761655).
  * Add patch and lintian-overrides to remove cmake file already included in
    cmake-data package (Closes: 760227).
  * Fix path for m4/ax_python_module.m4 in d/copyright.
  * Move wildcard section to top in d/copyright to fix lintian checks for
    superfluous files.
  * Drop python-simplejson from Build-Depends as there is no rebuild of the AMQP
    frame definitions.
  * Wrap Depends lines.
  * Remove PHONY target declarations.

 -- Michael Fladischer <FladischerMichael@fladi.at>  Tue, 16 Sep 2014 14:02:06 +0200

librabbitmq (0.5.1-1) unstable; urgency=low

  * New upstream release (Closes: #758089).
  * Remove amqp_get_server_properties patch as it was included upstream.

 -- Michael Fladischer <FladischerMichael@fladi.at>  Thu, 14 Aug 2014 15:27:18 +0200

librabbitmq (0.5.0-1) unstable; urgency=medium

  [ Michael Fladischer ]
  * New upstream release (Closes: #757553).
  * Update librabbitmq1.symbols.
  * Drop cmake_multiarch.patch as it has been included upstream.
  * Add lintian override for missing PGP signature on source tarball.
  * Make package multi-arch capable.

  [ Brian May ]
  * Add missing amqp_get_server_properties symbol. Closes: #757745.

 -- Brian May <bam@debian.org>  Mon, 11 Aug 2014 13:26:37 +1000

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,13 @@
 Priority: optional
 Section: libs
 Maintainer: Michael Fladischer <FladischerMichael@fladi.at>
+Uploaders: Brian May <bam@debian.org>
 Build-Depends: cmake,
                debhelper (>= 9),
                docbook-to-man,
                libpopt-dev,
                libssl-dev,
-               libtool,
-               python-simplejson
+               libtool
 Standards-Version: 3.9.5
 Homepage: https://github.com/alanxz/rabbitmq-c
 Vcs-Git: git://anonscm.debian.org/collab-maint/librabbitmq.git
@@ -17,7 +17,9 @@
 Package: librabbitmq-dev
 Section: libdevel
 Architecture: any
-Depends: librabbitmq1 (= ${binary:Version}), ${misc:Depends}
+Multi-Arch: same
+Depends: librabbitmq1 (= ${binary:Version}),
+         ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Description: AMQP client library written in C - Dev Files
  RabbitMQ provides robust messaging for applications. It is easy to use, fit
@@ -30,8 +32,12 @@
 Package: librabbitmq-dbg
 Section: debug
 Architecture: any
+Multi-Arch: same
 Priority: extra
-Depends: librabbitmq1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: librabbitmq1 (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
+Pre-Depends: ${misc:Pre-Depends}
 Description: AMQP client library written in C - Debug Files
  RabbitMQ provides robust messaging for applications. It is easy to use, fit
  for purpose at cloud scale and supported on all major operating systems and
@@ -42,7 +48,9 @@
 
 Package: librabbitmq1
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Multi-Arch: same
+Depends: ${misc:Depends},
+         ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Description: AMQP client library written in C
  RabbitMQ provides robust messaging for applications. It is easy to use, fit
@@ -55,7 +63,9 @@
 Package: amqp-tools
 Architecture: any
 Section: net
-Depends: librabbitmq1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: librabbitmq1 (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
 Description: Command-line utilities for interacting with AMQP servers
  RabbitMQ provides robust messaging for applications. It is easy to use, fit
  for purpose at cloud scale and supported on all major operating systems and
